<template>
  <div
    class="container-xxl"
  >
    <div class="row mt-10">
      <div class="flex-column col-xxl-4 col-xl-4 col-lg-4 col-xs-12 mb-5">
        <div class="card shadow-sm">
          <div
            v-if="response.mostrar === 'LOADING'"
            class="d-flex justify-content-center py-20"
          >
            <div
              class="spinner-border text-primary"
              style="width: 4rem; height: 4rem; border-width: 0.35rem"
              role="status"
            >
              <span class="visually-hidden">Cargando...</span>
            </div>
          </div>
          <div
            v-else
            class="card-body"
          >
            <div class="d-flex flex-column mb-3">
              <div class="d-flex justify-content-center mb-4">
                <div class="symbol symbol-125px symbol-xl-150px symbol-fixed position-relative">
                  <img
                    :src="proveedor.urlImagen"
                    alt="Logo proveedor"
                    class="align"
                  >
                </div>
              </div>
              <div class="d-flex flex-column align-items-start mb-2">
                <div class="d-flex flex-column w-100">
                  <div class="align-self-center mb-2">
                    <label
                      class="text-gray-900 fs-3 fw-bolder"
                      v-text="proveedor.nombre"
                    />
                  </div>
                  <div class="d-flex justify-content-around">
                    <div class="d-flex flex-wrap fw-bold fs-5">
                      <label class="d-flex align-items-center text-gray-600 me-5 mb-2">
                        <i class="bi bi-receipt me-2" />
                        {{ proveedor.nit }}
                      </label>
                    </div>
                    <div class="d-flex flex-wrap fw-bold fs-5">
                      <label class="d-flex align-items-center text-gray-600 me-5 mb-2">
                        <i class="bi bi-telephone-fill me-2" />
                        {{ proveedor.telefono }}
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <label class="fs-4 fw-bolder text-dark">Geolocalización y Dirección</label>
            <div class="mb-5">
              <GoogleMap
                api-key="AIzaSyA2XeZf5gGUwUTKl9y-hq2GsMdTlCJCgds"
                style="width: 100%; height: 300px"
                :center="{lat: proveedor.latitud, lng: proveedor.longitud}"
                :zoom="15"
              >
                <Marker :options="{ position: {lat: proveedor.latitud, lng: proveedor.longitud}, draggable: false, clickable: false }" />
              </GoogleMap>
            </div>
            <div class="d-flex flex-wrap fw-bold fs-5">
              <label class="d-flex align-items-center text-gray-600 me-5 mb-2">
                <i class="bi bi-signpost me-2" />
                {{ proveedor.direccion }}
              </label>
            </div>
          </div>
        </div>
      </div>

      <div class="col-lg-8 col-xs-12 d-flex flex-column">
        <div class="card card-flush shadow-sm">
          <div class="card-header d-flex flex-column flex-md-row">
            <h3 class="card-title fw-bolder text-dark">
              Lista de productos
            </h3>
            <div class="card-toolbar justify-content-end">
              <button
                class="btn btn-success shadow-sm"
                data-bs-toggle="modal"
                data-bs-target="#modal_producto_crear"
              >
                <i class="bi bi-plus-lg fs-4 me-2" />Agregar
              </button>
              <button
                class="btn btn-primary ms-5"
                @click="onProductoListar()"
              >
                <i class="bi bi-arrow-clockwise fs-4 me-2" />Actualizar
              </button>
            </div>
          </div>
        </div>

        <div>
          <tabla-listar
            ref="tablaProductoListar"
            @on-producto-mostrar="onProductoMostrar"
            @on-producto-editar="onProductoEditar"
            @on-producto-eliminar="onProductoEliminar"
          />
        </div>
      </div>
    </div>

    <modal-crear @on-producto-listar="onProductoListar" />
    <modal-mostrar :producto="sProducto" />
    <modal-editar
      :producto="sProducto"
      @on-producto-listar="onProductoListar"
    />
    <modal-eliminar
      :producto="sProducto"
      @on-producto-listar="onProductoListar"
    />
  </div>
</template>

<script>
import TablaListar from '@/components/panel/proveedor/producto/TablaProductoListar.vue';
import ModalCrear from '@/components/panel/proveedor/producto/ModalProductoCrear.vue';
import ModalMostrar from '@/components/panel/proveedor/producto/ModalProductoMostrar.vue';
import ModalEditar from '@/components/panel/proveedor/producto/ModalProductoEditar.vue';
import ModalEliminar from '@/components/panel/proveedor/producto/ModalProductoEliminar.vue';

import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import { GoogleMap, Marker  } from "vue3-google-map";
import Clonar from "@/core/util/Clonar";

export default {
  name: 'ProveedorMostrar',
  components: {
    GoogleMap, Marker, TablaListar, ModalCrear, ModalMostrar, ModalEditar, ModalEliminar
  },
  data() {
    return {
      sProducto: {},
      proveedor: {
        id: '', nombre: '', nit: '', direccion: '', telefono: '',
        urlImagen: '', urlThumbnail: '', latitud: '', longitud: ''
      },
      response: {
        mostrar: 'LOADING',
      }
    }
  },

  mounted() {
    this.onProveedorMostrar();
  },

  methods: {
    onProveedorMostrar() {
      this.response.mostrar = 'LOADING';
      Servicio.get(Ruta.rutaPanelProveedorMostrar(this.$route.params.id)).then( (data) => {
        this.proveedor = data.data;
        this.response.mostrar = data.estado;
      }).catch( (error) => {
        this.response.mostrar = 'ERROR';
        Toast.mostrarError(error);
      });
    },

    onProductoListar() {
      this.$refs.tablaProductoListar.onProductoListar();
    },

    onProductoMostrar(producto) {
      this.sProducto = Clonar.clon(producto);
    },

    onProductoEditar(producto) {
      this.sProducto = Clonar.clon(producto);
    },

    onProductoEliminar(producto) {
      this.sProducto = Clonar.clon(producto);
    }
  },
}
</script>